.xlist
;---------------------------------------------------------------;
;	IBM PC definition	 	 			;
;---------------------------------------------------------------;




SEG_BIOS	equ	0040h		; BIOS work area segment

BIOS_DATA	struc
 BiosComLst	dw	4 dup(?)	; 0: COM port address list
 BiosLptLst	dw	4 dup(?)	; 8: LPT port address list
		db	2 dup(?)
 		db	?
 		dw	?
 		db	?
 		db	?
 BiosKbSft	db	?,?		; 17: keyboard shift flags
		db	?
 BiosKbHead	dw	?		; 1A: key buffer top ptr
 BiosKbTail	dw	?		; 1C: key buffer tail ptr
 BiosKbBuff	dw	16 dup(?)	; 1E: key buffer
		db	?		; 3E: recalibration flags
		db	?		; 3F: motor status
		db	?		; 40: motor shut off timer
		db	?		; 
		db	7 dup(?)	; 42: FDC status
 BiosVideoMode	db	?		; 49: current video mode
 BiosCrtWidth	dw	?		; 4A: CRT width
 BiosCrtSize	dw	?		; 4C: video buffer size
 BiosCrtTop	dw	?		; 4E: top address in video buffer
 BiosCsrPos	dw	8 dup(?)	; 50: cursor posisions
 BiosCsrForm	dw	?		; 60: cursor form
 BiosActivePage	db	?		; 62: active page
		dw	?		; 63: CRTC address
		db	?		; 65: mode control reg.
		db	?		; 66: color select reg.
		db	5 dup(?)
 BiosClock	dd	?		; 6C: daily timer counter
 BiosClkOvf	db	?		; 70: daily timer counter overflow flag
 BiosBreak	db	?		; 71: ^Break flag
 BiosSreset	dw	?		; 72: software reset command
		db	?
		db	?
		db	?
		db	?
		db	4 dup(?)
		db	4 dup(?)
		dw	?
		dw	?
 BiosCrtRows	db	?		; 84: screen lines -1
 BiosCharLines	dw	?		; 85: char. height (lines)
		db	79h dup(?)	; (other parameters)
 BiosPrnScFlag	db	?		; 100: print screen job flag
BIOS_DATA	ends



$VIDEO		macro	func,par	; video I/F
	IFNB <par>
		mov	ax,(func shl 8)+(par and 0ffh)
	ELSE
		mov	ah,func
	ENDIF
		 int	10h
		endm

$PRINT		macro	func,par	; printer I/F
	IFNB <par>
		mov	ax,(func shl 8)+(par and 0ffh)
	ELSE
		mov	ah,func
	ENDIF
		 int	17h
		endm

$KEY		macro	func,par	; keyboard I/F
	IFNB <par>
		mov	ax,(func shl 8)+(par and 0ffh)
	ELSE
		mov	ah,func
	ENDIF
		 int	16h
		endm

$RTC		macro	func,par	; RTC I/F
	IFNB <par>
		mov	ax,(func shl 8)+(par and 0ffh)
	ELSE
		mov	ah,func
	ENDIF
		 int	1ah
		endm

$DISK		macro	func,par	; DISK I/F
	IFNB <par>
		mov	ax,(func shl 8)+(par and 0ffh)
	ELSE
		mov	ah,func
	ENDIF
		int	13h
		endm

$SYSTEM		macro	func,par	; system service I/F
	IFNB <par>
		mov	ax,(func shl 8)+(par and 0ffh)
	ELSE
		mov	ah,func
	ENDIF
		 int	15h
		endm


;**  End of File **
.list
